package com.ruoyi.demo.entity.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.time.LocalDateTime;

@Data
public class EquipmentVo {
    @NotBlank(groups = {EditGroup.class, QueryGroup.class})
    private String equipmentId;
    @NotBlank(groups = {AddGroup.class, EditGroup.class})
    private String equipmentName;
    @NotBlank(groups = {AddGroup.class, EditGroup.class})
    private String addrInfo;
    @NotBlank(groups = {AddGroup.class, EditGroup.class})
    private String addrCode;
    private String addrCodeInfo;

    private BigDecimal lat;
    private BigDecimal lng;
    @NotNull(groups = {AddGroup.class, EditGroup.class})
    private Integer state;
    private Integer onState;
    private String storeId;
    private String manufacturers;
    private String searchText;
    private String annotation;

    private int pageNum = 1;
    private int pageSize = 10;

    @NotBlank(groups = {AddGroup.class, EditGroup.class})
    private String maintainName;
    @NotBlank(groups = {AddGroup.class, EditGroup.class})
    private String maintainTelephone;
    private LocalDateTime enterTime;
    private LocalDateTime updateTime;
    private Integer deleted;
}
