package com.ruoyi.demo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.demo.entity.Statistics;
import com.ruoyi.demo.entity.bo.PlanBo;
import com.ruoyi.demo.entity.vo.PlanHomeVo;
import com.ruoyi.demo.entity.vo.ScanListVo;
import com.ruoyi.demo.mapper.StatisticsMapper;
import com.ruoyi.demo.service.StatisticsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class StatisticsServiceImpl implements StatisticsService {
    @Autowired
    StatisticsMapper statisticsMapper;

    @Override
    public PageInfo<List<ScanListVo>> getScanList(PlanBo bo) {
        PageHelper.startPage(bo.getPageNum(),bo.getPageSize(),true);
        QueryWrapper<Statistics> queryWrapper = new QueryWrapper<>();
        if (bo.getStartTime() != null)
            queryWrapper.apply("DATE_FORMAT(`time`,'%Y-%m-%d %H:%i:%s') >= DATE_FORMAT({0},'%Y-%m-%d %H:%i:%s')",bo.getStartTime());
        if (bo.getEndTime() != null)
            queryWrapper.apply("DATE_FORMAT(`time`,'%Y-%m-%d %H:%i:%s') <= DATE_FORMAT({0},'%Y-%m-%d %H:%i:%s')",bo.getEndTime());
        List<Statistics> list = statisticsMapper.selectList(queryWrapper);
        List<ScanListVo> vos = new ArrayList<>();
        for (Statistics statistics : list){
            vos.add(new ScanListVo(statistics));
        }
        return new PageInfo(vos);
    }

    @Override
    public PlanHomeVo getScanTotal() {
        PlanHomeVo vo = new PlanHomeVo();
        vo.setTotal(statisticsMapper.selectTotal());
        vo.setTime(LocalDateTime.now());
        return vo;
    }

    @Override
    public int add(Statistics bo) {
        return statisticsMapper.insert(bo);
    }
}
